<?php

/**
 * cbr_comite_termina actions.
 *
 * @package    cobro_coactivo
 * @subpackage cbr_comite_termina
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:43Z Kris.Wallsmith $
 */

class cbr_comite_terminaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_COMITE_TERMINA',
        'CBR_COMITE_CARTERA',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CBR_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_COMITE_CARTERA,LEFT' =>
        array(
            'id_comite_cartera' => 'CBR_COMITE_TERMINA'
        ),
        'CBR_REMISION_TITULO,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_COMITE_CARTERA'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_COMITE_TERMINA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_COMITE_TERMINA' =>
        array(
            'id_comite_termina' => 'id_comite_termina',
            'id_comite_cartera' => 'id_comite_cartera',
            'no_auto' => 'no_auto',
            'fecha_auto' => 'fecha_auto',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'id_tipo_documento' => 'id_tipo_documento',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'fecha_aprueba' => 'fecha_aprueba',
            'usuario_aprueba' => 'usuario_aprueba'
        ),
        'CBR_COMITE_CARTERA' =>
        array(
            'id_comite_cartera' => 'id_comite_cartera_car',
            'id_remision_titulo' => 'id_remision_titulo',
            'no_comite' => 'no_comite',
            'fecha_comite' => 'fecha_comite',
            'observaciones' => 'observaciones_car',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log_car',
            'usuario_log' => 'usuario_log_car'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado_remision_titulo',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'anho_remision desc', 'cod_titulo', 'fecha_auto', 'no_auto'
    ); //campos para el ordenamiento de la consulta

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_COMITE_TERMINA' =>
        array(
            'id_comite_termina,a' => array('!=' => array(-1)),
            'id_comite_termina,b' => array('=' => array('id_comite_termina')),
            'id_comite_cartera' => array('=' => array('id_comite_cartera')),
            'fecha_auto' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'no_auto' => array('' => array('no_auto')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo')),
            'numero_remision' => array('=' => array('numero_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            'anho_remision' => array('=' => array('id_anhos')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_comite_termina'; //identificador de la tabla
    protected $id_names = array('id_comite_termina'); //llave primaria
    protected $field_names = array('id_comite_cartera', 'no_auto', 'fecha_auto', 'observaciones', 'adjunto',
        'id_tipo_documento', 'usuario_log', 'fecha_aprueba', 'usuario_aprueba'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_COMITE_TERMINA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_comite_termina'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {


                $id_comite_termina = $list_data_post[0]['id_comite_termina'];

                //Actualizacion del consecutivo
                if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {


                    $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    $id_anhos = $records[0]['id_anhos'];
                    $id_tipo_documento = $list_data_post[0]['id_tipo_documento'];
                    $consecutivo = $list_data_post[0]['no_auto'];
                    $consecutivo = $consecutivo * 1;


                    //Valida exista consecutivo - 20170424
                    if ($consecutivo != 1) {

                        $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo = $consecutivo  
    where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                    } else {

                        $sql = <<<EOD
Insert into CBR_CONSECUTIVO_DOC (ID_CONSECUTIVO_DOC,ID_TIPO_DOCUMENTO,ID_ANHOS,CONSECUTIVO) 
    values (null,'$id_tipo_documento','$id_anhos','$consecutivo') 
EOD;
                    }

                    $this->conn->execute($sql);

                    //Se actualiza el estado de comite cartera - 20200715::LAVILA
                    $sql = <<<EOD
update cbr_comite_cartera set estado = 1 
    where id_comite_cartera = (select id_comite_cartera from cbr_comite_termina 
        where id_comite_termina = $id_comite_termina)  
EOD;


                    $this->conn->execute($sql);
                    
                    //Metodo Sobreescribir Documento
                    //setlocale(LC_ALL, 'es_ES');
                    //$fechaDocumento = date('d-F-Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");
                    $dia = date('d',strtotime($list_data_post[0]['fecha_aprueba']));
                    $mes = $meses[date('m',strtotime($list_data_post[0]['fecha_aprueba'])) - 1];
                    $año = date('Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $fechaDocumento = "$dia - $mes - $año";
                    $datosModificar = Array(
                        'numeroDocumento' => $list_data_post[0]['no_auto'],
                        'fechaDocumento' => $fechaDocumento
                    );
                    //Obtenemos la ruta donde e almacena el adjunto
                    
                    $ruta_documento = getcwd() . "/uploads/termina_comite/";
                    $documento = $ruta_documento.$list_data_post[0]['adjunto'];
                    $logger->info("Actualizar Documento - " . $documento);
                    $new_documento = CN_TABLE::sobreescribirDocumentoWord($datosModificar, $documento);
                    $logger->info("Se Actaulizo el documento - $documento y se creo $new_documento");
                    // Actualizamos el archivo en el campo Adjunto
                    $sql = <<<EOD
update cbr_comite_termina SET ADJUNTO = '$new_documento'  
 where id_comite_termina = $id_comite_termina
EOD;
                    $this->conn->execute($sql);

                    //LLamar envioNotificacion
                    $this->envioNotificacion($request, $id_comite_termina);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                //Actualizacion del consecutivo
                if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {


                    $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    $id_anhos = $records[0]['id_anhos'];
                    $id_comite_termina = $list_data_post[0]['id_comite_termina'];
                    $id_tipo_documento = $list_data_post[0]['id_tipo_documento'];
                    $consecutivo = $list_data_post[0]['no_auto'];
                    $consecutivo = $consecutivo * 1;


                    //Valida exista consecutivo - 20170424
                    if ($consecutivo != 1) {

                        $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo = $consecutivo  
    where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                    } else {

                        $sql = <<<EOD
Insert into CBR_CONSECUTIVO_DOC (ID_CONSECUTIVO_DOC,ID_TIPO_DOCUMENTO,ID_ANHOS,CONSECUTIVO) 
    values (null,'$id_tipo_documento','$id_anhos','$consecutivo') 
EOD;
                    }

                    $this->conn->execute($sql);

                    //Se actualiza el estado de comite cartera - 20200715::LAVILA
                    $sql = <<<EOD
update cbr_comite_cartera set estado = 1 
    where id_comite_cartera = (select id_comite_cartera from cbr_comite_termina 
        where id_comite_termina = $id_comite_termina)  
EOD;


                    $this->conn->execute($sql);
                    
                    //Metodo Sobreescribir Documento
                    //setlocale(LC_ALL, 'es_ES');
                    //$fechaDocumento = date('d-F-Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");
                    $dia = date('d',strtotime($list_data_post[0]['fecha_aprueba']));
                    $mes = $meses[date('m',strtotime($list_data_post[0]['fecha_aprueba'])) - 1];
                    $año = date('Y',strtotime($list_data_post[0]['fecha_aprueba']));
                    $fechaDocumento = "$dia - $mes - $año";
                    $datosModificar = Array(
                        'numeroDocumento' => $list_data_post[0]['no_auto'],
                        'fechaDocumento' => $fechaDocumento
                    );
                    //Obtenemos la ruta donde e almacena el adjunto
                    
                    $ruta_documento = getcwd() . "/uploads/termina_comite/";
                    $documento = $ruta_documento.$list_data_post[0]['adjunto'];
                    $logger->info("Actualizar Documento - " . $documento);
                    $new_documento = CN_TABLE::sobreescribirDocumentoWord($datosModificar, $documento);
                    $logger->info("Se Actaulizo el documento - $documento y se creo $new_documento");
                    // Actualizamos el archivo en el campo Adjunto
                    $sql = <<<EOD
update cbr_comite_termina SET ADJUNTO = '$new_documento'  
 where id_comite_termina = $id_comite_termina
EOD;
                    $this->conn->execute($sql);

                    //LLamar envioNotificacion
                    $this->envioNotificacion($request, $id_comite_termina);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];

            //Actualizacion del consecutivo
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {

                $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_anhos = $records[0]['id_anhos'];

                $id_tipo_documento = $request['id_tipo_documento'];


                $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc 
    where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                $records = CN_TABLE::executeSQL($sql);

                //Valida exista consecutivo - 20170424
                if (count($records) > 0) {
                    $consecutivo = $records[0]['consecutivo'];
                    $request['no_auto'] = $consecutivo + 1;
                } else {
                    $request['no_auto'] = 1;
                }
                $request['no_auto'] = str_pad($request['no_auto'], 4, "0", STR_PAD_LEFT);
                $logger->info("Consecutivo no_auto::" . $request['no_auto']);

                $request['usuario_aprueba'] = $request['id_username'];
                $request['fecha_aprueba'] = CN_TABLE::fechaSistema();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            //Actualizacion del consecutivo
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {

                $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                $records = CN_TABLE::executeSQL($sql);
                $id_anhos = $records[0]['id_anhos'];

                $id_tipo_documento = $request['id_tipo_documento'];


                $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                $records = CN_TABLE::executeSQL($sql);

                //Valida exista consecutivo - 20170424
                if (count($records) > 0) {
                    $consecutivo = $records[0]['consecutivo'];
                    $request['no_auto'] = $consecutivo + 1;
                } else {
                    $request['no_auto'] = 1;
                }
                $request['no_auto'] = str_pad($request['no_auto'], 4, "0", STR_PAD_LEFT);
                $logger->info("Consecutivo no_auto::" . $request['no_auto']);

                $request['usuario_aprueba'] = $request['id_username'];
                $request['fecha_aprueba'] = CN_TABLE::fechaSistema();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Correo de notificacion de aprobacion - 20200304
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacion($request, $id_filtro) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }

        /**
         * Envio de correo de error - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CBR_COMITE_TERMINA');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
avoc.id_comite_termina as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
                
avoc.id_comite_termina,
avoc.no_auto,
remi.numero_remision,
remi.anho_remision as id_anhos,
remi.cod_titulo,
ter.id_tipo_doc,
ter.num_doc,
ter.razon_soc,
abo.email as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
'Se realiza la aprobación del Auto de terminación registo '|| tipdoc.descripcion || ' No.'|| avoc.no_auto || ' del titulo minero ' || remi.cod_titulo  || ', verificar recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision 
    || ', se envia correo al abogado( '|| ter.num_doc || '-' || ter.razon_soc ||' ).' as mensaje,
'Aprobacion Terminación de Comite Cartera - No.'|| remi.numero_remision || '-' || remi.anho_remision || ' del Titulo: ' || remi.cod_titulo as subject,                        
                
--datos de envio
ter.num_doc as num_doc_env,
ter.id_tipo_doc as id_tipo_doc_env,
ter.razon_soc as razon_social_env,
abo.email as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.nombre as razon_social_usu,
usu.email as correo_usu

from CBR_COMITE_TERMINA avoc

left join cbr_comite_cartera cfp
on cfp.id_comite_cartera=avoc.id_comite_cartera

left join cbr_tipo_documento tipdoc
on tipdoc.id_tipo_documento = avoc.id_tipo_documento

left join cbr_reparto repa
on repa.id_remision_titulo = cfp.id_remision_titulo

left join cbr_remision_titulo remi
on cfp.id_remision_titulo = remi.id_remision_titulo

left join cbr_abogado abo
on abo.id_abogado = repa.id_abogado

left join interceros_v ter
on ter.id_mae_ter = abo.id_mae_ter

left join usuario usu
on usu.username = '$username'

where
avoc.id_comite_termina = $id_filtro
and avoc.no_auto is not null
and repa.estado = 1    
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            /**
             * Datos de envio
             *
              $params = array(
              'user_from' => 'webservice',
              'recipients' => $recipients,
              'asunto' => 'Error webservie_sigm_consulta',
              'body' => $body
              );
             * 
             */
            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
        }

        $logger->info("Envio de correo fin");
    }

}
